package com.example.endpoint.hl7v2.inbound;

import ca.uhn.fhir.util.ClasspathUtil;
import ca.uhn.hl7v2.HL7Exception;
import ca.uhn.hl7v2.model.Message;
import ca.uhn.hl7v2.model.v25.message.ADT_A01;

public class BaseHl7v2InterceptorTest {

	public static final String SAMPLE_ADT_A01_PATIENT_IDENTIFIER = "7000135";
	public static final String SAMPLE_ADT_A01_PATIENT_IDENTIFIER_SYSTEM = "http://acme.org/mrns";
	public static final String SAMPLE_ADT_A01_PATIENT_IDENTIFIER_CODE = "MR";

	protected Message createSampleAdtA01() {
		String resourcePath = "sample-adt-a01.hl7";
		String rawMessage = ClasspathUtil.loadResource(resourcePath);
		rawMessage = normalizeHl7v2MessageNewLineCharacters(rawMessage);
		ADT_A01 adtA01 = new ADT_A01();
		try {
			adtA01.parse(rawMessage);
			return adtA01;
		} catch (HL7Exception e) {
			String errorMessage = String.format("Could not parse Message from: %s", resourcePath);
			throw new RuntimeException(errorMessage, e);
		}
	}

	private String normalizeHl7v2MessageNewLineCharacters(String theRawHl7v2Message){
		return theRawHl7v2Message.replace("\r\n", "\n").replace("\n", "\r");
	}
}
